<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- jsextension-utilities.qdoc -->
  <title>Utilities Service | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >Utilities Service</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<p class="naviNextPrevious headerNavi">
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#available-operations">Available Operations</a></li>
<li class="level2"><a href="#cstringquote">cStringQuote</a></li>
<li class="level2"><a href="#gethash">getHash</a></li>
<li class="level2"><a href="#rfc1034identifier">rfc1034Identifier</a></li>
<li class="level2"><a href="#versioncompare">versionCompare</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Utilities Service</h1>
<span class="subtitle"></span>
<!-- $$$jsextension-utilities.html-description -->
<div class="descr"> <a name="details"></a>
<p>The <code>Utilities</code> service offers miscellaneous operations.</p>
<a name="available-operations"></a>
<h2 id="available-operations">Available Operations</h2>
<a name="cstringquote"></a>
<h3 id="cstringquote">cStringQuote</h3>
<pre class="cpp plain">

  Utilities.cStringQuote(str: string): string

</pre>
<p>Takes a string and escapes special characters in a way that the result is suitable for use as a C/C++ string literal. This function is typically used to specify values for <a href="qml-qbsmodules-cpp.html#defines-prop">cpp.defines</a>.</p>
<a name="gethash"></a>
<h3 id="gethash">getHash</h3>
<pre class="cpp plain">

  Utilities.getHash(key: string): string

</pre>
<p>Calculates a 16-byte hash of the input and returns it. Rules in modules should use this function to find unique locations for output artifacts in the build directory without duplicating the whole directory structure of the respective input file (to deal with the case of two files with the same name in different subdirectories of the same product).</p>
<a name="rfc1034identifier"></a>
<h3 id="rfc1034identifier">rfc1034Identifier</h3>
<pre class="cpp plain">

  Utilities.rfc1034Identifier(str: string): string

</pre>
<p>Returns an RFC-1034 compliant identifier based on the given string by replacing each character that is not Latin alphanumeric or <code>.</code> with <code>-</code>.</p>
<a name="versioncompare"></a>
<h3 id="versioncompare">versionCompare</h3>
<pre class="cpp plain">

  Utilities.versionCompare(version1: string, version2: string): number

</pre>
<p>Interprets the two arguments as version numbers and returns a number that is smaller than, equal to, or greater than zero if <code>version1</code> is smaller than, equal to, or greater than <code>version2</code>, respectively.</p>
<p>The version strings consist of up to three numbers separated by dots.</p>
</div>
<!-- @@@jsextension-utilities.html -->
<p class="naviNextPrevious footerNavi">
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
